/*									TPFH Ralit virtuelle								*
 *											(ESIEA)										*
 ****************************************************************************************/
#include <windows.h>					// En-tte standart aux prog. Windows
#include <gl\gl.h>						// fonctions OpenGL
#include <gl\glaux.h>					// Librairie AUX
#include <math.h>

#define LARGEUR 500
#define HAUTEUR 500

GLfloat sol[3][3] = {{0.0f,0.0f,0.05f},
					{4.0f,0.0f,0.05f},
					{0.0f,4.0f,0.05f}};
GLfloat ombre[4][4];
GLfloat light_pos[] = {0.0f, 0.0f, 15.0f, 1.0f};

void Vecteur_Unite(float vector[3])
{
       float length;
       
			// Calcul de la norme du vecteur                
       length = (float)sqrt((vector[0]*vector[0]) + (vector[1]*vector[1]) + (vector[2]*vector[2]));
       
       if(length == 0.0f) length = 1.0f;  //vite une violente erreur !!!
       vector[0] /= length;
       vector[1] /= length;
       vector[2] /= length;
}

// Points p1, p2, & p3 spcifis dans le sens trigonomtrique
void Normale(float v[3][3], float out[3])
{
       float v1[3],v2[3];
       static const int x = 0;
       static const int y = 1;
       static const int z = 2;

			// Calcul de 2 vecteurs  partir des 3 points
       v1[x] = v[0][x] - v[1][x];
       v1[y] = v[0][y] - v[1][y];
       v1[z] = v[0][z] - v[1][z];
       v2[x] = v[1][x] - v[2][x];
       v2[y] = v[1][y] - v[2][y];
       v2[z] = v[1][z] - v[2][z];

			// calcul du produit vectoriel
       out[x] = (v1[y]*v2[z] - v1[z]*v2[y]);
       out[y] = (v1[z]*v2[x] - v1[x]*v2[z]);
       out[z] = (v1[x]*v2[y] - v1[y]*v2[x]);

		// on le rduit  un vecteur unit
       Vecteur_Unite(out);
}

void MakeShadowMatrix(GLfloat points_plan[3][3], GLfloat lightPos[4], GLfloat destMat[4][4]) 
{ 
	GLfloat planeCoeff[4];
	GLfloat dot; 


		//on calcule un vecteur normal  ce plan 
	Normale(points_plan,planeCoeff); 


		// le dernier coefficient se calcule par substitution 
	planeCoeff[3] = - ( (planeCoeff[0]*points_plan[2][0]) + (planeCoeff[1]*points_plan[2][1]) + (planeCoeff[2]*points_plan[2][2]));
	dot = planeCoeff[0] * lightPos[0] + planeCoeff[1] * lightPos[1] + planeCoeff[2] * lightPos[2] + planeCoeff[3] * lightPos[3]; 


		// maintenant, on projte 
		// 1re colonne 
	destMat[0][0] = dot - lightPos[0] * planeCoeff[0]; 
	destMat[1][0] = 0.0f - lightPos[0] * planeCoeff[1]; 
	destMat[2][0] = 0.0f - lightPos[0] * planeCoeff[2]; 
	destMat[3][0] = 0.0f - lightPos[0] * planeCoeff[3]; 


		// 2me colonne 
	destMat[0][1] = 0.0f - lightPos[1] * planeCoeff[0]; 
	destMat[1][1] = dot - lightPos[1] * planeCoeff[1]; 
	destMat[2][1] = 0.0f - lightPos[1] * planeCoeff[2]; 
	destMat[3][1] = 0.0f - lightPos[1] * planeCoeff[3]; 


		// 3me colonne 
	destMat[0][2] = 0.0f - lightPos[2] * planeCoeff[0]; 
	destMat[1][2] = 0.0f - lightPos[2] * planeCoeff[1]; 
	destMat[2][2] = dot - lightPos[2] * planeCoeff[2]; 
	destMat[3][2] = 0.0f - lightPos[2] * planeCoeff[3]; 


		// 4me colonne 
	destMat[0][3] = 0.0f - lightPos[3] * planeCoeff[0]; 
	destMat[1][3] = 0.0f - lightPos[3] * planeCoeff[1]; 
	destMat[2][3] = 0.0f - lightPos[3] * planeCoeff[2]; 
	destMat[3][3] = dot - lightPos[3] * planeCoeff[3]; 
}

void cube(int ombre)
{
	GLfloat Rouge[] = {0.8f, 0.0f, 0.0f, 1.0f};
	GLfloat Vert[]  = {0.0f, 0.8f, 0.0f, 1.0f};
	GLfloat Bleu[]  = {0.0f, 0.0f, 0.8f, 1.0f};
	GLfloat Jaune[]  = {0.8f, 0.8f, 0.0f, 1.0f};
	GLfloat Rose[]  = {0.8f, 0.0f, 0.8f, 1.0f};
	GLfloat	Cyan[]  = {0.0f, 0.8f, 0.8f, 1.0f};

	glBegin(GL_QUADS);
			//Si il s'agit de l'ombre, 
			//on dessine le cube noir lgrement transparent
		if (!ombre) glColor4fv(Rouge); else glColor4f(0.0f, 0.0f, 0.0f, 0.25f);
		glNormal3d(0.0,0.0,1.0);
		glVertex3d(-1,  1, 1);
		glVertex3d(-1, -1, 1);
		glVertex3d( 1, -1, 1);
		glVertex3d( 1,  1, 1);
		if (!ombre) glColor4fv(Jaune);
		glNormal3d(-1.0,0.0,0.0);
		glVertex3d( -1,  1,  1);
		glVertex3d( -1,  1, -1);
		glVertex3d( -1, -1, -1);
		glVertex3d( -1, -1,  1);
		if (!ombre) glColor4fv( Vert);
		glNormal3d(1.0,0.0,0.0);
		glVertex3d( 1,  1,  1);
		glVertex3d( 1, -1,  1);
		glVertex3d( 1, -1, -1);
		glVertex3d( 1,  1, -1);
		if (!ombre) glColor4fv( Rose);
		glNormal3d(0.0,1.0,0.0);
		glVertex3d( -1, 1,  1);
		glVertex3d(  1, 1,  1);
		glVertex3d(  1, 1, -1);
		glVertex3d( -1, 1, -1);
		if (!ombre) glColor4fv( Bleu);
		glNormal3d(0.0,-1.0,0.0);
		glVertex3d( -1, -1,  1);
		glVertex3d( -1, -1, -1);
		glVertex3d(  1, -1, -1);
		glVertex3d(  1, -1,  1);
		if (!ombre) glColor4fv( Cyan);
		glNormal3d(0.0,0.0,-1.0);
		glVertex3d(  1,  1, -1);
		glVertex3d(  1, -1, -1);
		glVertex3d( -1, -1, -1);
		glVertex3d( -1,  1, -1);		   
	glEnd();
}

void drawFloor()
{
	GLfloat Gris[] = {0.25f, 0.25f, 0.25f, 1.0f};
	glColor4fv(Gris);
	glBegin(GL_QUADS);
		  glVertex3f(-4.0,  4.0, 0.0);
		  glVertex3f( 4.0,  4.0, 0.0);
		  glVertex3f( 4.0, -4.0, 0.0);
		  glVertex3f(-4.0, -4.0, 0.0);
	glEnd();
}

void SetLight()
{
        GLfloat ambientProperties[] = {0.7f, 0.7f, 0.7f, 1.0f};
        GLfloat diffuseProperties[] = {1.0f, 1.0f, 1.0f, 1.0f};
        glLightfv( GL_LIGHT0, GL_AMBIENT, ambientProperties);
        glLightfv( GL_LIGHT0, GL_DIFFUSE, diffuseProperties);
        glLightfv( GL_LIGHT0, GL_POSITION, light_pos);
        glEnable(GL_LIGHT0);
        glEnable(GL_LIGHTING);
		glEnable(GL_COLOR_MATERIAL);
}

void CALLBACK Main_part(void)
{
    	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);  
		SetLight();
			//on dessine la scne normalement
		drawFloor();
    	glPushMatrix();
		glTranslatef(0.0f, 0.0f, 5.0f);
		glRotatef((80.0f), -0.5f, 0.3f, -0.8f);
		glRotatef((10.0f), 0.5f, -0.3f, 0.8f);
			//dessin du cube en couleur normale 
		cube(0);
    	glPopMatrix();
	
			//on initialise la transparence
		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
			//Calcul de la matrice de projection sur le sol
		MakeShadowMatrix(sol,light_pos,ombre);
		glPushMatrix();	
		glMultMatrixf((GLfloat *) ombre);	
			//dessin de l'objet
		glTranslatef(0.0f, 0.0f, 5.0f);
        glRotatef((80.0f), -0.5f, 0.3f, -0.8f);
        glRotatef((10.0f), 0.5f, -0.3f, 0.8f);
			//on dessine le cube en noir transparent
        cube(1);
	glPopMatrix();
	
	glDisable(GL_BLEND);
	auxSwapBuffers();
}

void CALLBACK reshape (int width, int height)
{
	glViewport (0, 0, width, height);
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	gluPerspective (45.0, ((GLfloat) width) / ((GLfloat) height),1.0,100.0);
	glMatrixMode (GL_MODELVIEW);
	glLoadIdentity ();
	gluLookAt (0.0,-7.0,15.0, 0.0, 0.0, 0.0,0.0,0.0, 1.0);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_POLYGON_SMOOTH);
	SetLight();
}

int main (int argc, char *argv[])
{
	auxInitDisplayMode(AUX_DOUBLE | AUX_RGBA | AUX_DEPTH | AUX_STENCIL);
	auxInitPosition(100,100,LARGEUR,HAUTEUR); 
	auxInitWindow("Reflet");
	auxReshapeFunc(reshape);
	auxMainLoop(Main_part);
	return 0;
}
